/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */


import { HTMLStencilElement, JSXBase } from './stencil.core';
import {
  Services,
} from 'microbit-web-bluetooth';
import {
  DeviceInformation,
} from 'microbit-web-bluetooth/types/services/device-information';

export namespace Components {
  interface MicrobitButtonA {
    /**
    * The CSS class to use when long-pressed
    */
    'longPressClass': string;
    /**
    * The CSS class to use when released
    */
    'releaseClass': string;
    'services': Services;
    /**
    * The CSS class to use when short-pressed
    */
    'shortPressClass': string;
  }
  interface MicrobitButtonB {
    /**
    * The CSS class to use when long-pressed
    */
    'longPressClass': string;
    /**
    * The CSS class to use when released
    */
    'releaseClass': string;
    'services': Services;
    /**
    * The CSS class to use when short-pressed
    */
    'shortPressClass': string;
  }
  interface MicrobitCalibrate {
    /**
    * The button label to calibrate
    */
    'calibrateLabel': string;
    'services': Services;
  }
  interface MicrobitCompass {
    'services': Services;
  }
  interface MicrobitConnect {
    /**
    * The button label to connect
    */
    'connectLabel': string;
    'device': BluetoothDevice;
    /**
    * The button label to disconnect
    */
    'disconnectLabel': string;
  }
  interface MicrobitConnection {
    /**
    * The CSS class to use when connected
    */
    'connectedClass': string;
    'device': BluetoothDevice;
    /**
    * The CSS class to use when disconnected
    */
    'disconnectedClass': string;
  }
  interface MicrobitFirmware {
    'deviceInformation': DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
    /**
    * The text shown when no firmware version
    */
    'noInfo': string;
  }
  interface MicrobitHardware {
    'deviceInformation': DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
    /**
    * The text shown when no hardware version
    */
    'noInfo': string;
  }
  interface MicrobitManufacturer {
    'deviceInformation': DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
    /**
    * The text shown when no manufacturer name
    */
    'noInfo': string;
  }
  interface MicrobitMatrix {
    /**
    * The template for identifying child LEDs
    */
    'idTemplate': string;
    /**
    * The CSS class for off LEDs
    */
    'offClass': string;
    /**
    * The CSS class for on LEDs
    */
    'onClass': string;
    'services': Services;
  }
  interface MicrobitModel {
    'deviceInformation': DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
    /**
    * The text shown when no model number
    */
    'noInfo': string;
  }
  interface MicrobitMovement {
    /**
    * The frequency to read the sensor
    */
    'frequency': number;
    /**
    * The CSS class to use when moved
    */
    'movedClass': string;
    /**
    * The sensitivity of the sensor
    */
    'sensitivity': number;
    'services': Services;
    /**
    * The CSS class to use when still
    */
    'stillClass': string;
  }
  interface MicrobitName {
    'device': BluetoothDevice;
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
  }
  interface MicrobitReceive {
    'services': Services;
  }
  interface MicrobitSend {
    /**
    * The text shown on the button
    */
    'buttonLabel': string;
    /**
    * The delimiter to use
    */
    'delimiter': string;
    'services': Services;
  }
  interface MicrobitSerial {
    'deviceInformation': DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
    /**
    * The text shown when no serial number
    */
    'noInfo': string;
  }
  interface MicrobitTemperature {
    /**
    * The text shown when disconnected
    */
    'disconnectedText': string;
    /**
    * The text shown when no temperature
    */
    'noTemperature': string;
    'services': Services;
    /**
    * The interval to check the temperature (ms)
    */
    'temperaturePeriod': number;
    /**
    * The text to display after the temperature
    */
    'temperatureSuffix': string;
  }
  interface MicrobitText {
    /**
    * The text shown on the button
    */
    'buttonLabel': string;
    /**
    * The speed to scroll the text
    */
    'scrollDelay': number;
    'services': Services;
  }
}

declare global {


  interface HTMLMicrobitButtonAElement extends Components.MicrobitButtonA, HTMLStencilElement {}
  var HTMLMicrobitButtonAElement: {
    prototype: HTMLMicrobitButtonAElement;
    new (): HTMLMicrobitButtonAElement;
  };

  interface HTMLMicrobitButtonBElement extends Components.MicrobitButtonB, HTMLStencilElement {}
  var HTMLMicrobitButtonBElement: {
    prototype: HTMLMicrobitButtonBElement;
    new (): HTMLMicrobitButtonBElement;
  };

  interface HTMLMicrobitCalibrateElement extends Components.MicrobitCalibrate, HTMLStencilElement {}
  var HTMLMicrobitCalibrateElement: {
    prototype: HTMLMicrobitCalibrateElement;
    new (): HTMLMicrobitCalibrateElement;
  };

  interface HTMLMicrobitCompassElement extends Components.MicrobitCompass, HTMLStencilElement {}
  var HTMLMicrobitCompassElement: {
    prototype: HTMLMicrobitCompassElement;
    new (): HTMLMicrobitCompassElement;
  };

  interface HTMLMicrobitConnectElement extends Components.MicrobitConnect, HTMLStencilElement {}
  var HTMLMicrobitConnectElement: {
    prototype: HTMLMicrobitConnectElement;
    new (): HTMLMicrobitConnectElement;
  };

  interface HTMLMicrobitConnectionElement extends Components.MicrobitConnection, HTMLStencilElement {}
  var HTMLMicrobitConnectionElement: {
    prototype: HTMLMicrobitConnectionElement;
    new (): HTMLMicrobitConnectionElement;
  };

  interface HTMLMicrobitFirmwareElement extends Components.MicrobitFirmware, HTMLStencilElement {}
  var HTMLMicrobitFirmwareElement: {
    prototype: HTMLMicrobitFirmwareElement;
    new (): HTMLMicrobitFirmwareElement;
  };

  interface HTMLMicrobitHardwareElement extends Components.MicrobitHardware, HTMLStencilElement {}
  var HTMLMicrobitHardwareElement: {
    prototype: HTMLMicrobitHardwareElement;
    new (): HTMLMicrobitHardwareElement;
  };

  interface HTMLMicrobitManufacturerElement extends Components.MicrobitManufacturer, HTMLStencilElement {}
  var HTMLMicrobitManufacturerElement: {
    prototype: HTMLMicrobitManufacturerElement;
    new (): HTMLMicrobitManufacturerElement;
  };

  interface HTMLMicrobitMatrixElement extends Components.MicrobitMatrix, HTMLStencilElement {}
  var HTMLMicrobitMatrixElement: {
    prototype: HTMLMicrobitMatrixElement;
    new (): HTMLMicrobitMatrixElement;
  };

  interface HTMLMicrobitModelElement extends Components.MicrobitModel, HTMLStencilElement {}
  var HTMLMicrobitModelElement: {
    prototype: HTMLMicrobitModelElement;
    new (): HTMLMicrobitModelElement;
  };

  interface HTMLMicrobitMovementElement extends Components.MicrobitMovement, HTMLStencilElement {}
  var HTMLMicrobitMovementElement: {
    prototype: HTMLMicrobitMovementElement;
    new (): HTMLMicrobitMovementElement;
  };

  interface HTMLMicrobitNameElement extends Components.MicrobitName, HTMLStencilElement {}
  var HTMLMicrobitNameElement: {
    prototype: HTMLMicrobitNameElement;
    new (): HTMLMicrobitNameElement;
  };

  interface HTMLMicrobitReceiveElement extends Components.MicrobitReceive, HTMLStencilElement {}
  var HTMLMicrobitReceiveElement: {
    prototype: HTMLMicrobitReceiveElement;
    new (): HTMLMicrobitReceiveElement;
  };

  interface HTMLMicrobitSendElement extends Components.MicrobitSend, HTMLStencilElement {}
  var HTMLMicrobitSendElement: {
    prototype: HTMLMicrobitSendElement;
    new (): HTMLMicrobitSendElement;
  };

  interface HTMLMicrobitSerialElement extends Components.MicrobitSerial, HTMLStencilElement {}
  var HTMLMicrobitSerialElement: {
    prototype: HTMLMicrobitSerialElement;
    new (): HTMLMicrobitSerialElement;
  };

  interface HTMLMicrobitTemperatureElement extends Components.MicrobitTemperature, HTMLStencilElement {}
  var HTMLMicrobitTemperatureElement: {
    prototype: HTMLMicrobitTemperatureElement;
    new (): HTMLMicrobitTemperatureElement;
  };

  interface HTMLMicrobitTextElement extends Components.MicrobitText, HTMLStencilElement {}
  var HTMLMicrobitTextElement: {
    prototype: HTMLMicrobitTextElement;
    new (): HTMLMicrobitTextElement;
  };
  interface HTMLElementTagNameMap {
    'microbit-button-a': HTMLMicrobitButtonAElement;
    'microbit-button-b': HTMLMicrobitButtonBElement;
    'microbit-calibrate': HTMLMicrobitCalibrateElement;
    'microbit-compass': HTMLMicrobitCompassElement;
    'microbit-connect': HTMLMicrobitConnectElement;
    'microbit-connection': HTMLMicrobitConnectionElement;
    'microbit-firmware': HTMLMicrobitFirmwareElement;
    'microbit-hardware': HTMLMicrobitHardwareElement;
    'microbit-manufacturer': HTMLMicrobitManufacturerElement;
    'microbit-matrix': HTMLMicrobitMatrixElement;
    'microbit-model': HTMLMicrobitModelElement;
    'microbit-movement': HTMLMicrobitMovementElement;
    'microbit-name': HTMLMicrobitNameElement;
    'microbit-receive': HTMLMicrobitReceiveElement;
    'microbit-send': HTMLMicrobitSendElement;
    'microbit-serial': HTMLMicrobitSerialElement;
    'microbit-temperature': HTMLMicrobitTemperatureElement;
    'microbit-text': HTMLMicrobitTextElement;
  }
}

declare namespace LocalJSX {
  interface MicrobitButtonA extends JSXBase.HTMLAttributes<HTMLMicrobitButtonAElement> {
    /**
    * The CSS class to use when long-pressed
    */
    'longPressClass'?: string;
    /**
    * The CSS class to use when released
    */
    'releaseClass'?: string;
    'services'?: Services;
    /**
    * The CSS class to use when short-pressed
    */
    'shortPressClass'?: string;
  }
  interface MicrobitButtonB extends JSXBase.HTMLAttributes<HTMLMicrobitButtonBElement> {
    /**
    * The CSS class to use when long-pressed
    */
    'longPressClass'?: string;
    /**
    * The CSS class to use when released
    */
    'releaseClass'?: string;
    'services'?: Services;
    /**
    * The CSS class to use when short-pressed
    */
    'shortPressClass'?: string;
  }
  interface MicrobitCalibrate extends JSXBase.HTMLAttributes<HTMLMicrobitCalibrateElement> {
    /**
    * The button label to calibrate
    */
    'calibrateLabel'?: string;
    'services'?: Services;
  }
  interface MicrobitCompass extends JSXBase.HTMLAttributes<HTMLMicrobitCompassElement> {
    'services'?: Services;
  }
  interface MicrobitConnect extends JSXBase.HTMLAttributes<HTMLMicrobitConnectElement> {
    /**
    * The button label to connect
    */
    'connectLabel'?: string;
    'device'?: BluetoothDevice;
    /**
    * The button label to disconnect
    */
    'disconnectLabel'?: string;
  }
  interface MicrobitConnection extends JSXBase.HTMLAttributes<HTMLMicrobitConnectionElement> {
    /**
    * The CSS class to use when connected
    */
    'connectedClass'?: string;
    'device'?: BluetoothDevice;
    /**
    * The CSS class to use when disconnected
    */
    'disconnectedClass'?: string;
  }
  interface MicrobitFirmware extends JSXBase.HTMLAttributes<HTMLMicrobitFirmwareElement> {
    'deviceInformation'?: DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
    /**
    * The text shown when no firmware version
    */
    'noInfo'?: string;
  }
  interface MicrobitHardware extends JSXBase.HTMLAttributes<HTMLMicrobitHardwareElement> {
    'deviceInformation'?: DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
    /**
    * The text shown when no hardware version
    */
    'noInfo'?: string;
  }
  interface MicrobitManufacturer extends JSXBase.HTMLAttributes<HTMLMicrobitManufacturerElement> {
    'deviceInformation'?: DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
    /**
    * The text shown when no manufacturer name
    */
    'noInfo'?: string;
  }
  interface MicrobitMatrix extends JSXBase.HTMLAttributes<HTMLMicrobitMatrixElement> {
    /**
    * The template for identifying child LEDs
    */
    'idTemplate'?: string;
    /**
    * The CSS class for off LEDs
    */
    'offClass'?: string;
    /**
    * The CSS class for on LEDs
    */
    'onClass'?: string;
    'services'?: Services;
  }
  interface MicrobitModel extends JSXBase.HTMLAttributes<HTMLMicrobitModelElement> {
    'deviceInformation'?: DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
    /**
    * The text shown when no model number
    */
    'noInfo'?: string;
  }
  interface MicrobitMovement extends JSXBase.HTMLAttributes<HTMLMicrobitMovementElement> {
    /**
    * The frequency to read the sensor
    */
    'frequency'?: number;
    /**
    * The CSS class to use when moved
    */
    'movedClass'?: string;
    /**
    * The sensitivity of the sensor
    */
    'sensitivity'?: number;
    'services'?: Services;
    /**
    * The CSS class to use when still
    */
    'stillClass'?: string;
  }
  interface MicrobitName extends JSXBase.HTMLAttributes<HTMLMicrobitNameElement> {
    'device'?: BluetoothDevice;
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
  }
  interface MicrobitReceive extends JSXBase.HTMLAttributes<HTMLMicrobitReceiveElement> {
    'services'?: Services;
  }
  interface MicrobitSend extends JSXBase.HTMLAttributes<HTMLMicrobitSendElement> {
    /**
    * The text shown on the button
    */
    'buttonLabel'?: string;
    /**
    * The delimiter to use
    */
    'delimiter'?: string;
    'services'?: Services;
  }
  interface MicrobitSerial extends JSXBase.HTMLAttributes<HTMLMicrobitSerialElement> {
    'deviceInformation'?: DeviceInformation;
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
    /**
    * The text shown when no serial number
    */
    'noInfo'?: string;
  }
  interface MicrobitTemperature extends JSXBase.HTMLAttributes<HTMLMicrobitTemperatureElement> {
    /**
    * The text shown when disconnected
    */
    'disconnectedText'?: string;
    /**
    * The text shown when no temperature
    */
    'noTemperature'?: string;
    'services'?: Services;
    /**
    * The interval to check the temperature (ms)
    */
    'temperaturePeriod'?: number;
    /**
    * The text to display after the temperature
    */
    'temperatureSuffix'?: string;
  }
  interface MicrobitText extends JSXBase.HTMLAttributes<HTMLMicrobitTextElement> {
    /**
    * The text shown on the button
    */
    'buttonLabel'?: string;
    /**
    * The speed to scroll the text
    */
    'scrollDelay'?: number;
    'services'?: Services;
  }

  interface IntrinsicElements {
    'microbit-button-a': MicrobitButtonA;
    'microbit-button-b': MicrobitButtonB;
    'microbit-calibrate': MicrobitCalibrate;
    'microbit-compass': MicrobitCompass;
    'microbit-connect': MicrobitConnect;
    'microbit-connection': MicrobitConnection;
    'microbit-firmware': MicrobitFirmware;
    'microbit-hardware': MicrobitHardware;
    'microbit-manufacturer': MicrobitManufacturer;
    'microbit-matrix': MicrobitMatrix;
    'microbit-model': MicrobitModel;
    'microbit-movement': MicrobitMovement;
    'microbit-name': MicrobitName;
    'microbit-receive': MicrobitReceive;
    'microbit-send': MicrobitSend;
    'microbit-serial': MicrobitSerial;
    'microbit-temperature': MicrobitTemperature;
    'microbit-text': MicrobitText;
  }
}

export { LocalJSX as JSX };


declare module "@stencil/core" {
  export namespace JSX {
    interface IntrinsicElements extends LocalJSX.IntrinsicElements {}
  }
}


